/*
****************************************************************************************
GUIDS
****************************************************************************************
*/

;#define GUID_IID_IClassFactory <00000001h, 00000h, 00000h, 0C0h, 000h, 000h, 000h, 000h, 000h, 000h, 046h>
;#define GUID_IID_IUnknown <000000000h, 00000h, 00000h, 0C0h, 00h, 00h, 00h, 00h, 00h, 00h, 046H>
;#define GUID_IID_IShellExtInit <0000214e8h, 00000h, 00000h, 0c0h, 000h, 000h, 000h, 000h, 000h, 000h, 046h>
;#define GUID_IID_IContextMenu <0000214e4h, 00000h, 00000h, 0c0h, 000h, 000h, 000h, 000h, 000h, 000h, 046h>
;#define GUID_CLSID_ShellExtension <087b9bd00h, 0c65ch, 011cdh, 0a2h, 059h, 000h, 0ddh, 001h, 00eh, 08ch, 028h>
// {A4D98869-9265-4c49-9A1B-C865CFA02F57}
#define GUID_CLSID_ShellExtension <0xa4d98869, 0x9265, 0x4c49, 0x9a, 0x1b, 0xc8, 0x65, 0xcf, 0xa0, 0x2f, 0x57>

/*
****************************************************************************************
API Aliases
****************************************************************************************
*/

;RegCreateKey = RegCreateKeyA
;RegSetValueEx = RegSetValueExA
;GetModuleFileName = GetModuleFileNameA
;RegSetValue = RegSetValueA
;RegOpenKey = RegOpenKeyA
;RegDeleteKey = RegDeleteKeyA
;InsertMenu = InsertMenuA
;lstrcpy = lstrcpyA
;lstrcat = lstrcatA
;lstrcpyn = lstrcpynA
;DragQueryFile = DragQueryFileA
;MessageBox = MessageBoxA

/*
****************************************************************************************
Macros
****************************************************************************************
*/

/*
CoInvoke(%pInterface,%Method,%0,%1,%2,%3,%4,%5,%6,%7,%8,%9) MACRO
	#IF ARGCOUNT = 12 
		push %9 
	#ENDIF 
	#IF ARGCOUNT > 10 
		push %8 
	#ENDIF 
	#IF ARGCOUNT > 9 
		push %7 
	#ENDIF 
	#IF ARGCOUNT > 8 
		push %6 
	#ENDIF 
	#IF ARGCOUNT > 7 
		push %5 
	#ENDIF 
	#IF ARGCOUNT > 6 
		push %4 
	#ENDIF 
	#IF ARGCOUNT > 5 
		push %3 
	#ENDIF 
	#IF ARGCOUNT > 4 
		push %2 
	#ENDIF 
	#IF ARGCOUNT > 3 
		push %1 
	#ENDIF 
	#IF ARGCOUNT > 2 
		push %0 
	#ENDIF 
	push [%pInterface] 
	mov eax, [%pInterface] 
	mov eax,[eax] 
	add eax, %Method 
	call [eax]
ENDM
*/

/*
****************************************************************************************
Constants
****************************************************************************************
*/

/*
#Define DLL_PROCESS_DETACH 0
#Define DLL_PROCESS_ATTACH 1
#Define DLL_THREAD_ATTACH 2
#Define DLL_THREAD_DETACH 3

#Define NULL 0
#Define TRUE 1
#Define FALSE 0

#Define TYMED_HGLOBAL 1

#Define HKEY_CLASSES_ROOT 80000000h
#Define REG_SZ 1

#Define ERROR_SUCCESS 0
#Define NOERROR 0

#Define CP_ACP 0
#Define MAX_PATH 260

#Define SHCNE_ASSOCCHANGED 8000000h
#Define SHCNF_IDLIST 0

#Define CLASS_E_NOAGGREGATION 80040110h
#Define CLASS_E_CLASSNOTAVAILABLE 80040111h
#Define E_OUTOFMEMORY 8007000Eh
#Define E_NOINTERFACE 80004002h
#Define E_INVALIDARG 80070057h
#define E_FAIL  (0x80004004)

#Define CF_HDROP 15
#Define DVASPECT_CONTENT 1

#define GCS_VERBA  0x00000000
#define GCS_HELPTEXTA  0x00000001
#define GCS_VALIDATEA  0x00000002
#define GCS_VERBW  0x00000004
#define GCS_HELPTEXTW  0x00000005
#define GCS_VALIDATEW  0x00000006
#define GCS_UNICODE  0x00000004

#Define CMF_DEFAULTONLY 1
#Define MF_BYPOSITION 400h
#Define MF_SEPARATOR 800h
#Define MF_STRING 0h

#Define S_OK 0h
#Define S_FALSE 1h
*/

/*
****************************************************************************************
Structures
****************************************************************************************
*/

/*
GUID STRUCT
    Data1     dd
    Data2     dw
    Data3     dw
    Data4     db
        db
        db
        db
        db
        db
        db
        db
GUID ENDS

POINT STRUCT
  x  DD
  y  DD
POINT ENDS

Unknown STRUCT
	QueryInterface	DD
	AddRef			DD
	Release			DD
ENDS

CMINVOKECOMMANDINFOEX STRUCT
	cbSize DD
	fMask DD
	hwnd DD
	lpVerb DD
	lpParameters DD
	lpDirectory DD
	nShow DD
	dwHotKey DD
	hIcon DD
	lpTitle DD
	lpVerbW DD
	lpParametersW DD
	lpDirectoryW DD
	lpTitleW DD
	ptInvoke POINT <>
ENDS

IDataObject STRUCT
	IUnknown Unknown <>
	GetData DD
	GetDataHere DD
	QueryGetData DD
	GetCanonicalFormatEtc DD
	SetData DD
	EnumFormatEtc DD
	DAdvise DD
	DUnadvise DD
	EnumDAdvise DD
ENDS

STGMEDIUM STRUCT
	tymed DD
	handle DD
	pUnkForRelease  DD
ENDS

FORMATETC STRUCT
	cfFormat DD
	ptd DD
	dwAspect DD
	lindex DD
	tymed DD
ENDS

*/


/*
IClassFactory STRUCT
	IUnknown		Unknown	<offset ClassFactoryQueryInterface, offset ClassFactoryAddRef, offset ClassFactoryRelease>
	CreateInstance	DD	OFFSET ClassFactoryCreateInstance
	LockServer		DD	OFFSET ClassFactoryLockServer
ENDS

IShellExtension STRUCT
	IUnknown	Unknown	<offset ShellExtQueryInterface, offset ShellExtAddRef, offset ShellExtRelease>
	Initialize	DD	offset ShellExtInitialize
ENDS

IContextMenu STRUCT
	IUnknown Unknown <offset ContextMenuQueryInterface, offset ContextMenuAddRef, offset ContextMenuRelease>
	QueryContextMenu DD offset ContextMenuQueryContextMenu
	InvokeCommand DD offset ContextMenuInvokeCommand
	GetCommandString DD offset ContextMenuGetCommandString
ENDS
*/

;ClassFactoryObject  STRUCT
	; interface object
;	lpVtbl			DD		0
	; object data
;	nRefCount		DD		1
;ENDS

;ContextMenuObject STRUCT
	; interface object
;	lpVtbl			DD		offset vtIContextMenu
	; object data
;	nRefCount		DD		0
;ENDS

;ShellExtObject STRUCT
	; interface object
;	lpVtbl			DD		0
	; object data
;	nRefCount		DD		1
;ENDS